
#pragma once

#include <string>
#include <iostream>

namespace ro::upb::etti {
    struct Student {
    protected:
        std::string name;
        int age;
    public:
        Student() = default;

        Student(const std::string & name, int age) : name(name), age(age) {

        }

        std::string& getName() {
            return name;
        }

        virtual void incAge() {
            age++;
            std::cout << "S-a apelat incAge din Student pentru studentul " << name << std::endl;
        }

        int getAge() const {
            return age;
        }
    };

    struct StudentWithGrade : Student {
        double grade;

        StudentWithGrade() = default;

        StudentWithGrade(const std::string & _name, int age, double grade) : Student(_name, age), grade(grade) {
            std::cout << "Am construit obiectul Student cu numele " << name << std::endl;
        }

        void incAge() override {
            age += 2;
            std::cout << "S-a apelat incAge din StudentWithGrade pentru studentul " << name <<  std::endl;
        }
    };
}
