//
// Created by rhobincu on 4/4/23.
//

#pragma once

#include <iostream>

namespace etti::pclp2 {
    /**
     * @brief Class template that represents an auto-resizable vector.
     * @tparam T The type of elements this vector holds.
     */
    template<typename T, size_t S> class Array {
        T *mData;

    public:

        Array() : mData(new T[S]) {
            static_assert(S > 0, "Size can't be 0");
            std::cout << "S-a apelat constructorul fara argument" << std::endl;
        }

        Array(const Array &source) : mData(new T[S]) {
            for (size_t i = 0; i < S; i++) mData[i] = source.mData[i];
            std::cout << "S-a apelat constructorul de copiere" << std::endl;
        }

        Array(Array &&source) : mData(source.mData) {
            source.mData = nullptr;
            std::cout << "S-a apelat constructorul de mutare" << std::endl;
        }

        Array &operator=(const Array &source) {
            if (&source == this) return *this;
            for (size_t i = 0; i < S; i++) mData[i] = source.mData[i];
            std::cout << "S-a apelat operatorul de atribuire" << std::endl;
            return *this;
        }

        Array &operator=(Array &&source) {
            delete[] mData;
            mData = source.mData;
            source.mData = nullptr;
            std::cout << "S-a apelat operatorul de mutare" << std::endl;
            return *this;
        }

        size_t size() const {
            return S;
        }

        T &at(size_t index) {
            return mData[index];
        }

        T at(size_t index) const {
            return mData[index];
        }

        T &operator[](size_t index) {
            return mData[index];
        }

        T operator[](size_t index) const {
            return mData[index];
        }

        T &front() {
            return mData[0];
        }

        T front() const {
            return mData[0];
        }

        T &back() {
            return mData[S - 1];
        }

        T back() const {
            return mData[S - 1];
        }

        ~Array() {
            delete[] mData;
            std::cout << "S-a apelat destructorul" << std::endl;
        }
    };
}
