#pragma once

#include <cmath>

struct Shape {
    virtual double getArea() = 0;
};

class Square : public Shape {
protected:
    double side;
public:
    Square(double side) : side(side) {

    }

    double getArea() override {
        return side * side;
    }
};

class Circle : public Shape {
    double radius;
public:
    Circle(double radius) : radius(radius) {

    }

    double getArea() override {
        return radius * radius * M_PI;
    }
};

class Rectangle : public Square {
    double side2;
public:
    Rectangle(double side1, double side2) : Square(side1), side2(side2) {

    }

    double getArea() override {
        return side * side2;
    }
};

class Triangle : public Shape {
    double side1, side2, side3;
public:
    Triangle(double side1, double side2, double side3) : side1(side1), side2(side2), side3(side3) {

    }

    double getArea() override {
        double sp = (side1 + side2 + side3) / 2;
        return sqrt(sp * (sp - side1) * (sp - side2) * (sp - side3));
    }
};
